{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client1:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Client2:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Client3:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Client4:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Client5:{routeName:'BaseController-getComboValues',table:'clients'}
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O'}}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);

            const gridConfig = {
                cm: [
                    {header: "{{ 'TaskListLaser.plannedstart'|trans }}", dataIndex: 'plannedstart', width: 120,filter:'between', type:'date',alias:'tll',render:'datetime'},
                    {header: "{{ 'TaskListLaser.description'|trans }}", dataIndex: 'description', width: 450,filter:'single',alias:'tll',operator:'%.%'},
                    {header: "{{ 'TaskListLaser.production'|trans }}", dataIndex: 'production', width: 90}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.textField({
                        title: "{{ 'TaskListLaser.code'|trans }}",
                        dataIndex: 'code',
                        maxLength: 50,
                        labelWidth : '90px',
                        width : 150,
                        grid: 's4 m2',
                        hidden: true
                    }),
                    new mj.form.textField({
                        title: "{{ 'TaskListLaser.description'|trans }}",
                        dataIndex: 'description',
                        maxLength: 255,
                        labelWidth : '90px',
                        grid: 's12 m6',
                        width:341
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskListLaser.client'|trans }}",
                        placeHolder: "{{ 'TaskListLaser.client_placeholder'|trans }}",
                        dataIndex: 'client1',
                        labelWidth : '70px',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        right: true,
                        grid: 's12 m6',
                        store: t.extras.clients
                    }),
                    new mj.form.numberField({
                        title: "{{ 'TaskListLaser.production'|trans }}",
                        dataIndex: 'production',
                        labelWidth : '90px',
                        notEmpty: true,
                        width : 60,
                        grid: 's12 m6'
                    }),
                    new mj.form.dateField({
                        title: "{{ 'TaskListLaser.plannedstart'|trans }}",
                        dataIndex: 'plannedstart',
                        labelWidth : '120px',
                        itemStyle : 'padding-left:50px;',
                        grid: 's4 m2',
                        right:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskListLaser.client'|trans }}",
                        placeHolder: "{{ 'TaskListLaser.client_placeholder'|trans }}",
                        dataIndex: 'client2',
                        labelWidth : '70px',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        right: true,
                        grid: 's12 m6',
                        store: t.extras.clients
                    }),
                    /*new mj.form.combo({
                        title: "{{ 'TaskListLaser.client'|trans }}",
                        placeHolder: "{{ 'TaskListLaser.client_placeholder'|trans }}",
                        dataIndex: 'client1',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '90px',
                        grid: 's6 m4',
                        store: t.extras.clients
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskListLaser.client'|trans }}",
                        placeHolder: "{{ 'TaskListLaser.client_placeholder'|trans }}",
                        dataIndex: 'client2',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '90px',
                        grid: 's6 m4',
                        itemStyle : 'padding-left:10px;',
                        store: t.extras.clients,
                        right:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskListLaser.client'|trans }}",
                        placeHolder: "{{ 'TaskListLaser.client_placeholder'|trans }}",
                        dataIndex: 'client3',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '90px',
                        grid: 's6 m4',
                        itemStyle : 'padding-left:10px;',
                        store: t.extras.clients,
                        right:true
                    }),*/
                    
                    new mj.form.dateField({
                        title: "{{ 'TaskListLaser.start'|trans }}",
                        dataIndex: 'start',
                        labelWidth : '90px',
                        readOnly : true,
                        grid: 's4 m2'
                    }),
                    new mj.form.dateField({
                        title: "{{ 'TaskListLaser.finish'|trans }}",
                        dataIndex: 'finish',
                        labelWidth : '120px',
                        grid: 's4 m2',
                        itemStyle : 'padding-left:8px;',
                        right:true
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t.win.on('afterresize',function(){
                t.southLayout.doLayout();
            });
        },
        _setFormConfig:function(formConfig){
            const t = this;
            t.stores.form = new mj.store({failure:function(a,b){
				//console.log(a);
                //console.log(b);
                t.waitMaskHide();
			}});
            t.stores.form.on('load', t._onFormStoreLoad, t);
    
            t.forms = {};
            t.panel=new mj.panel({
                renderTo : t.tabs.main.form.getBody(),
                border : false,
                buttons:[
                    {
                        alt: mj.lng.glb.save,
                        cls: 'btn-sm left',
                        iconCls: 'mj-save',
                        //invisible: true,
                        scope: t,
                        handler: t._onButtonFormSubmitClick
                    },
                    {
                        alt: mj.lng.glb.cancel,
                        cls: 'btn-sm left',
                        iconCls: 'mj-list',
                        //invisible: true,
                        scope: t,
                        handler: t._onButtonFormCancelClick
                    }
                ]
            });
            t.windowButtons.formSubmit=false;
            t.windowButtons.formCancel=false;
            
            t.layout = new mj.layout({
                renderTo : t.panel.getBody(),
                layout : 'border',
                items : [
                    {
                        region  : 'north',
                        initial : 90,
                        min : 90,
                        max : 90,
                        split: false,
                        collapsible : false,
                        collapsed : false
                    }
                ]
            });
            
            t.forms.main = new mj.form(mj.apply({
                renderTo: t.layout.getBody('north'),//t.tabs.main.form.getBody(),
                modulename: t.modulename,
                store: t.stores.form,
                buttonPos:false
            }, formConfig));
            
            t.initDefaultButtons();
            t.buttons.formSubmit = t.panel.buttons[0];
            t.buttons.formCancel = t.panel.buttons[1];

            t.winAddChildRecord = new mj.window({
                renderTo : mj.NE(),
                title : '',
                modal : true,
                width : 400,
                height : 230,
                minWidth : 400,
                minHeight : 230,
                buttons : [
                    {title: mj.lng.glb.exit, handler:function(){t.winAddChildRecord.hide();}},
                    {title: mj.lng.glb.save}
                ]
            });
            
            t.win.addRelated(t.winAddChildRecord);
            
            t.forms.childRecords = new mj.form({
                renderTo : t.winAddChildRecord.getBody(),
                store : new mj.store({}),
                buttonPos:false
            });
            t.panelDetail=new mj.panel({
                renderTo : t.layout.getBody('center'),
                border : false   
            });
            t.grids.details = new mj.grid({
                win: t.win,
                renderTo: t.panelDetail.getBody('center'),
                store: [],
                pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent: true,
                cm : [
                    {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                    {header: "", dataIndex: 'tasklistlaser', width: 5,hide:true},
                    {header: "{{ 'TaskListLaser.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 100},
                    {header: "{{ 'TaskListLaser.opname'|trans }}", dataIndex: 'opname', width: 250},
                    {header: "{{ 'TaskListLaser.leafmask'|trans }}", dataIndex: 'leafmask', align:'right', width: 60},
                    {header: '', width: 5,hide:true}
                ]
            });

            for(var item in t.grids){
                if(item!='main'){
                    t.buttons['addBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnAddTable',alt:mj.lng.glb.add, iconCls : 'mj-add', disabled: true, handler : t.addChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'add'}});
                    t.buttons['editBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnEdit',alt:mj.lng.glb.edit,iconCls :'mj-edit', disabled:true, handler:t.editChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item,mode:'edit'}});
                    t.buttons['deleteBtn'+item] = t.grids[item].pbar.tbar.addButton({id:'btnDeleteTable',alt:mj.lng.glb.del, iconCls : 'mj-delete', disabled: true, handler:t.deleteChildRecordHandler,scope:{scope:t,grid:t.grids[item],item:item}});
                    t.grids[item].on('rowclick',function(g,s){
                        t.buttons['editBtn'+this].setEnable();
                        t.buttons['deleteBtn'+this].setEnable();
                    },item);
                    t.grids[item].on('rowdblclick',function(g,s){
                        this.handler.call(this.scope);
                    },t.buttons['editBtn'+item]);
                    t.grids[item].store.on('load',function(){
                        t.btnChildDisabler(this);
                        //t.buttons['addBtngroups'].setEnable();
                        if(item==='details'){
                            t.buttons['addBtndetails'].setEnable();
                        }
                    },item);
                    t.grids[item].load();
                }
            }
        },
        formCreator : function(g,i,m){
            var t=this;
            t.forms.childRecords.removeAll();
            switch (i){	
                case 'details':
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'id',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            hidden:true,
                            width : 50
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title : "tasklistlaser",
                            dataIndex : 'tasklistlaser',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 150,
                            hidden : true,
                            value : (m!='add'?t.forms.main.items[0].getValue():''),
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.textField({
                            title: "{{ 'TaskListLaser.erprefnumber'|trans }}",
                            dataIndex: 'erprefnumber',
                            maxLength: 50,
                            labelWidth : '110px',
                            grid: 's12 m6'
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.combo({
                            title : "{{ 'TaskListLaser.opname'|trans }}",
                            dataIndex : 'opname',
                            mode : 'remote',
                            store : t.stores.ProductTree,
                            width : 200,
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            notEmpty : true
                        })
                    );
                    t.forms.childRecords.add(
                        new mj.form.numberField({
                            title : "{{ 'TaskListLaser.leafmask'|trans }}",
                            dataIndex : 'leafmask',
                            labelWidth : '110px',
                            itemStyle : 'padding-top:5px;',
                            width : 50
                        })
                    );
            }
            if(m == 'edit'){
                t.forms.childRecords.store.data = g.selectedRow.data;
                t.forms.childRecords.load();
            }
        },
        saveChildRecord : function(){
            var t = this.scope, g = this.grid, m = this.mode, item = this.item, _err = false;
            var d =  t.forms.childRecords.getValue();
            if(item=='details'){
                //if(typeof d.code=='undefined'||d.code==''){
                //    _err = true;
                //    t.forms.childRecords.items[2].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
            }else{
                //t.forms.childRecords.items[1].clearInvalid();
                //if(typeof d.leafId=='undefined'||d.leafId==''){
                //    _err = true;
                //    t.forms.childRecords.items[1].markInvalid();
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
                //if((typeof d.leafmask=='undefined'||d.leafmask==''||parseInt("0"+d.leafmask)==0)&&!_err){
                //    _err = true;
                //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                //}
            }
            if(!_err){
                if(m == 'edit'){
                    //d._details = g.store.data[g.selectedRow.index]._details;
                    g.store.data[g.selectedRow.index] = d;
                }else{
                    g.store.data.push(d);
                }
                g.load();
                t.winAddChildRecord.hide();
            }
        },
        windowSetHandler : function(g,i,m){
            var t=this;
            t.winAddChildRecord.setTitle(m=='add'?mj.lng.glb.addRecord:mj.lng.glb.editRecord);
            t.winAddChildRecord.buttons[1].setHandler(t.saveChildRecord,{scope:t,grid:g,mode:m,item:i});
            t.formCreator(g,i,m);
        },        
        addChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            t.windowSetHandler(g,item,m);
            t.winAddChildRecord.show();
        },
        editChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            t.windowSetHandler(g,item,m);
            t.winAddChildRecord.show();
        },
        deleteChildRecordHandler : function(){
            var t = this.scope, g = this.grid, item = this.item, m = this.mode;
            new mj.message({
                title:mj.lng.glb.onay,
                modal : true,
                msg:mj.lng.glb.delQuestion,
                buttons:['NO','YES'],
                cb:function(el,btn){
                    if(btn=='YES'){
                        g.store.data.remove(g.store.data[g.selectedRow.index]);
                        g.load();
                    }
                    el.window.close();
                }
            });
        },
        btnChildDisabler:function(item){
            var btns = this.buttons;
            if(btns['addBtn'+item]&&typeof btns['addBtn'+item].setDisable == 'function')
                btns['addBtn'+item].setDisable();
            if(btns['editBtn'+item]&&typeof btns['editBtn'+item].setDisable == 'function')
                btns['editBtn'+item].setDisable();
            if(btns['deleteBtn'+item]&&typeof btns['deleteBtn'+item].setDisable == 'function')
                btns['deleteBtn'+item].setDisable();
        },
        _onButtonAddClick:function(){
            var t=this;
            t.grids.details.store.data=[];
            t.grids.details.load();
            t.newRecord();
        },
        _onFormStoreLoad:function(store){
            var t=this;
            if(store.recordCount>0){
                store.data=store.data[0];
                t.forms.main.loadForm();
                t.grids.details.store.data=store.data._details;
                t.grids.details.load();
                t.activateTabForm();
                t.waitMaskHide();
            }
        },
        editData:function(data){
            var t=this;
            var routeName = t.modulename + '-show';
            var route = Routing.getRoute(routeName);
            var data = {
                'id': data.id,
                'menuId': t.id
            };
            var url = Routing.generate(routeName, data);
            this.forms.main.store.modulename=t.modulename;
            this.forms.main.store.url=url;
            this.forms.main.store.method= route.methods[0];
            this.forms.main.store.load();
            t.waitMaskShow();
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    if(data.client1==null){
                        delete data.client1;
                    }
                    if(data.client2==null){
                        delete data.client2;
                    }
                    if(data.client3==null){
                        delete data.client3;
                    }
                    data.menuId = t.id;
                    data.details=t.grids.details.store.data;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
